"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.required = required;
exports.validate = validate;

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

function required(key) {
  return function (target, propertyKey, parameterIndex) {
    var metadata = "meta_".concat(propertyKey);
    target[metadata] = [].concat(_toConsumableArray(target[metadata] || []), [{
      index: parameterIndex,
      key: key
    }]);
  };
}

function validate(target, property, descriptor) {
  console.log({
    target: target,
    property: property,
    descriptor: descriptor
  });
  var fn = descriptor.value;

  descriptor.value = function () {
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    var metadata = "meta_".concat(property);
    target[metadata].forEach(function (metadata) {
      if (args[metadata.index] === undefined) {
        throw new Error("".concat(metadata.key, " is required"));
      }
    });
    return fn.apply(this, args);
  };

  return descriptor;
}